library(plyr)
library(conics)
library(mvtnorm)
library(msm)
library(stats)
library(matrixcalc)
library(truncdist)
library(gtools)
library(cluster)

library(RConics)
library(ellipse)

ellipse <- ellipse::ellipse
join <- plyr::join
tcrossprod <-base::tcrossprod

M<-matrix(c(1,0,0,1),2,2)
set.seed(5)

datos<-data.frame(rmvnorm(25,c(0,0),M))
datos<-rbind(datos,data.frame(rmvnorm(25,c(10,10),M)))
datos<-rbind(datos,data.frame(rmvnorm(30,c(0,20),M)))
datosnorm<-as.matrix(datos)


Data<-as.matrix(datosnorm)
#Data<-data.frame(ruspini)
#Data<-data.frame(faithful)


n<-length(Data[,1])
J<-8
k<-rep(1,J)
# Generate the 
Tw<-list()
Tw<-rep(list(matrix(solve(cov(Data)),2,2)),J)
mu<-matrix(rep(colMeans(Data),J),J,2,byrow=T)
v<-rep(2,J)
alpha <- rep(1,J)

# Generate the normal parameters
lambda <-list()
theta <- matrix(rep(numeric(),2*J),J,2);
w<-rdirichlet(1,alpha)
for(j in 1:J){lambda[[j]]<-matrix(rWishart(1,v[j],Tw[[j]]),2,2)
              theta[j,]<-rmvnorm(1,mu[j,],solve(k[j]*lambda[[j]]))}
cols<-c("royalblue4","darkred","black","mediumpurple4","skyblue3",
        "aquamarine4","bisque4","darkolivegreen4","goldenrod4",
        "plum4","seagreen4")[1:J]
innercolors<-c("royalblue1","brown1","gray75","mediumpurple1","skyblue1",
               "aquamarine1","bisque1","darkolivegreen1","goldenrod1",
               "plum1","seagreen1")[1:J]
ellipoints<-1000 ## MUST BE AN EVEN NUMBER

m<-rep(0,J);L<-20000
results<-data.frame(matrix(rep(0,n*L),L,n))
InfoCriteria<-data.frame(matrix(rep(Inf,3*L),L,3))
colnames(InfoCriteria)<-c("Akaike","Bayesian","Loglikelihood")
InfoCriteria$Loglikelihood<-rep(-Inf,L)

plot(Data,main=paste("Datos"));
setwd("C:/Users/Martha Doli/Desktop/Tesis")

hist_theta<-list()
hist_lambda<-list()
#Zdata<-data.frame(row.names = 1:n)
#Mode <- function(x) {ux <- unique(x);ux[which.max(tabulate(match(x, ux)))]}

