#######################################################################
############ Ending 2.1 ###############

row.names(head(InfoCriteria[order(InfoCriteria$Akaike),],10))
row.names(head(InfoCriteria[order(InfoCriteria$Bayesian),],5))
row.names(head(InfoCriteria[order(-InfoCriteria$Loglikelihood),],5))

AkaikeResults<-data.frame(iHCL=row.names(head(InfoCriteria[order(InfoCriteria$Akaike),],10)),
                          AkaikeValue=head(InfoCriteria[order(InfoCriteria$Akaike),1],10))
AkaikeResults<-cbind(AkaikeResults,zeros=rowSums(results[AkaikeResults$i,]==0))

BayesianResults<-data.frame(i=row.names(head(InfoCriteria[order(InfoCriteria$Bayesian),],10)),
                          BayesianValue=head(InfoCriteria[order(InfoCriteria$Bayesian),2],10))
BayesianResults<-cbind(BayesianResults,zeros=rowSums(results[BayesianResults$i,]==0))

LoglikelihoodResults<-data.frame(i=row.names(head(InfoCriteria[order(-InfoCriteria$Loglikelihood),],10)),
                          LoglikelihoodValue=head(InfoCriteria[order(-InfoCriteria$Loglikelihood),3],10))
LoglikelihoodResults<-cbind(LoglikelihoodResults,zeros=rowSums(results[LoglikelihoodResults$i,]==0))
AkaikeResults
BayesianResults
LoglikelihoodResults

#######################
#######################
####### Testing #######

selected<-c(16825,5886,13154,17901,149)
InfoCriteria[selected,]


for(s in 1:5){
test<-selected[s]
InfoCriteria[test,]

z<-as.numeric(results[test,])
z_ord<-z
for(i in 1:n) ## j variable represents the column
{
  z_ord[i]<-ifelse(z[i]==0,0,
                   ifelse(i==1,1,
                          ifelse(match(z[i],z)==i,
                                 max(z_ord[1:i-1])+1,
                                 z_ord[match(z[i],z)])))
}


def_J<-max(z_ord)
def_theta<-data.frame(theta_X=rep(0,def_J),theta_Y=rep(0,def_J))
def_lambda<-list()


pdf(paste("mtcars_resultado1_",test,".pdf",sep=""))
plot(Data,xlab="X",ylab="Y")
points(Data,bg="white",pch=21);
for(j in 1:def_J){
  clr=hsv(j/def_J, 1 ,.5)
  points(Data[which(z_ord==j),1],Data[which(z_ord==j),2],bg=clr,pch=21)
}
dev.off()

as.numeric(row.names(hist_theta[[test]][unique(as.numeric(results[test,])),]))
for(j in 1:def_J)
{
  def_theta[j,]   <- as.matrix(hist_theta[[test]][unique(z[which(z!=0)])[j],])
  def_lambda[[j]] <- matrix(c(hist_lambda[[test]][unique(z[which(z!=0)])[j],1],
                              hist_lambda[[test]][unique(z[which(z!=0)])[j],3],
                              hist_lambda[[test]][unique(z[which(z!=0)])[j],3],
                              hist_lambda[[test]][unique(z[which(z!=0)])[j],2]),2,2)
#  def_theta[j,]<-colMeans(Data[which(z_ord==j),])
#  def_lambda[[j]]<-solve(cov(Data[which(z_ord==j),]))
}

pdf(paste("mtcars_resultado2_",test,".pdf",sep=""))
plot(Data,xlab="X",ylab="Y")
for(j in def_J:1)
{
  for(t in 1:480)
  {
    lines(ellipse(solve(def_lambda[[j]]),centre=c(def_theta[j,1],def_theta[j,2]),level=(t/480)),
          col=hsv(j/def_J, (t/600) +.2 ,1))
  }
}

points(Data,pch=20,cex=1)

for(j in 1:def_J){
  clr=hsv(j/def_J, .9 ,.7)
  points(def_theta[j,],col=clr,pch=20,cex=1)
  points(def_theta[j,],pch=21,cex=1)
}
dev.off()
}

print(InfoCriteria[selected,])
for(s in 1:5){
  print(paste("Los valores de Theta con l=",selected[s]))
  print(hist_theta[[selected[s]]][unique(as.numeric(results[selected[s],])),])
  print(paste("Los valores de Lambda con l=",selected[s]))
  print(hist_lambda[[selected[s]]][unique(as.numeric(results[selected[s],])),c(1,3,3,2)])
}

