update_theta <- function(iter, m, Da, theta, lambda, u, mu)
{
  for(j in 1:length(theta))
  {
    if(m[j]!=0)
    {
      for(l in 1:iter)
      {
        b<-Inf
        a<--Inf
        for(i in 1:m[j])
        {
          b<-min(c(b,Da[[j]][[i]][1]-(lambda[[j]][1,2]/lambda[[j]][1,1])*(theta[[j]][2]-Da[[j]][[i]][2])+(sqrt((u[j]*lambda[[j]][1,1])+(lambda[[j]][1,2]^2-(lambda[[j]][1,1]*lambda[[j]][2,2]))*(theta[[j]][2]-Da[[j]][[i]][2])^2))/lambda[[j]][1,1]))
          a<-max(c(a,Da[[j]][[i]][1]-(lambda[[j]][1,2]/lambda[[j]][1,1])*(theta[[j]][2]-Da[[j]][[i]][2])-(sqrt((u[j]*lambda[[j]][1,1])+(lambda[[j]][1,2]^2-(lambda[[j]][1,1]*lambda[[j]][2,2]))*(theta[[j]][2]-Da[[j]][[i]][2])^2))/lambda[[j]][1,1]))
        }
        theta[[j]][1] <- rtnorm(1,(mu[[j]][1]-(lambda[[j]][1,2]/lambda[[j]][2,2])*(theta[[j]][2]-mu[[j]][2])),1/lambda[[j]][2,2],a,b)
        b<-Inf
        a<--Inf
        for(i in 1:m[j])
        {
          b<-min(c(b,Da[[j]][[i]][2]-(lambda[[j]][1,2]/lambda[[j]][2,2])*(theta[[j]][1]-Da[[j]][[i]][1])+(sqrt(u[j]*lambda[[j]][2,2]+(lambda[[j]][1,2]^2-lambda[[j]][1,1]*lambda[[j]][2,2])*(theta[[j]][1]-Da[[j]][[i]][1])^2))/lambda[[j]][2,2]))
          a<-max(c(a,Da[[j]][[i]][2]-(lambda[[j]][1,2]/lambda[[j]][2,2])*(theta[[j]][1]-Da[[j]][[i]][1])-(sqrt(u[j]*lambda[[j]][2,2]+(lambda[[j]][1,2]^2-lambda[[j]][1,1]*lambda[[j]][2,2])*(theta[[j]][1]-Da[[j]][[i]][1])^2))/lambda[[j]][2,2]))
        }
        theta[[j]][2] <- rtnorm(1,(mu[[j]][2]-(lambda[[j]][1,2]/lambda[[j]][1,1])*(theta[[j]][1]-mu[[j]][1])),1/lambda[[j]][1,1],a,b)  
      }
    }
    else
    {
      theta[[j]]<-rmvnorm(1,mu[[j]],solve(k*lambda[[j]]))
    }
  }
  return(theta)
}

update_lambda <-function(Tw,v,variable)
{
  for(j in 1:length(lambda))
  {
    lambda[[j]]<-matrix(rWishart(1,v[j],Tw[[j]]),2,2)
  }
  return(lambda)
}

projective_matrix_ellipse<-function(O,B,u)
{
  O<-matrix(O,1,2);B<-matrix(B,2,2)
  return(conicMatrix(c(B[1,1],2*B[2,1],B[2,2],-2*(B[1,1]*O[1]+B[2,1]*O[2]),
              -2*(B[2,1]*O[1]+B[2,2]*O[2]),(O%*%B%*%t(O))-u)))
}

plot_ellipse<-function(O,A,u)
{
  conicPlot(projective_matrix_ellipse(O,A,u))
}

#DD<-faithful[1:15,];lambda<-matrix(solve(cov(faithful)),2,2);u<-6+rexp(15);
#theta<-colMeans(faithful);names(theta)<-NULL;m<-15;mu<-c(2,50);

limits<-function(DD,theta,lambda,m,u,vert)
{
  a<--Inf;b<-Inf
  for(i in 1:m)
  {
    A<-matrix(projective_matrix_ellipse(c(DD[i,1],DD[i,2]),lambda,u[i]),3,3)
    if(vert==F)
    {P<-sort(intersectConicLine(A,c(0,1,-theta[2]))[1,])}
    else
    {P<-sort(intersectConicLine(A,c(1,0,-theta[1]))[2,])}
    a<-max(a,P[1]);b<-min(b,P[2])
  }
  return(list(a,b))
}

update_theta_v2_j<-function(DD,m,mu,theta,lambda,prevLambda,u,j,iter)
{
  uu<-u[which(z==j)]
  for(l in 1:iter)
  {
    a<-limits(DD,theta,prevLambda,m,uu,F)[[1]];b<-limits(DD,theta,prevLambda,m,uu,F)[[2]];
    theta[1]<-rtnorm(1,(mu[1]-(lambda[1,2]/lambda[2,2])*(theta[2]-mu[2])),
                     1/lambda[2,2],a,b)
    a<-limits(DD,theta,prevLambda,m,uu,T)[[1]];b<-limits(DD,theta,prevLambda,m,uu,T)[[2]];
    theta[2]<-rtnorm(1,(mu[2]-(lambda[1,2]/lambda[1,1])*(theta[1]-mu[1])),
                     1/lambda[1,1],a,b)
  }
  return(theta)
}

update_theta_v2<-function(DD,m,mu,k,theta,lambda,prevLambda,u,iter,variable)
{
  for(j in 1:length(lambda))
  {
    if(m[j]!=0 & variable[j]==T)
    {
      for(l in 1:iter)
      {
        uu<-u[which(z==j)]
        a<-limits(D[[j]],theta[j,],prevLambda[[j]],m[j],uu,F)[[1]];
        b<-limits(D[[j]],theta[j,],prevLambda[[j]],m[j],uu,F)[[2]];
        ## Here's theta_1
        theta[j,][1]<-rtnorm(1,(mu[j,][1]-(k[j]*lambda[[j]][1,2]/k[j]*lambda[[j]][2,2])*(theta[j,][2]-mu[j,][2])),
                             1/(k[j]*lambda[[j]][2,2]),a,b)
        a<-limits(D[[j]],theta[j,],prevLambda[[j]],m[j],uu,T)[[1]];
        b<-limits(D[[j]],theta[j,],prevLambda[[j]],m[j],uu,T)[[2]];
        ## Here's theta_2
        theta[j,][2]<-rtnorm(1,(mu[j,][2]-(k[j]*lambda[[j]][1,2]/k[j]*lambda[[j]][1,1])*(theta[j,][1]-mu[j,][1])),
                             1/(k[j]*lambda[[j]][1,1]),a,b)  
      }
    }
    else # WTF!???
    {
      #a<-qchisq(.95,4);b<-0
      #while (a>b) 
      #{
        theta[j,]<-rmvnorm(1,mu[j,],solve(lambda[[j]]))
      #  for(jj in 1:length(lambda))
      #  {
      #    if(jj!=j){b<-max(b,mahalanobis(theta[j,],theta[jj,],lambda[[jj]]))}
      # }
      #}
      # for(l in 1:30)
      # {
      #   theta[j,]<-rmvnorm(1,mu[j,],solve(lambda[[j]]));a<-1;
      #   for(j2 in 1:length(lambda))
      #   {
      #     if(j2%in%z==T){a<-a*(mahalanobis(theta[j2,],theta[j,],lambda[[j2]])>max(u[which(z==j2)]))}
      #   }
      #   if(a==1){break}
      # }
    }
  }
  return(theta)
}

update_theta_v3<-function(mu,lambda,theta,k)
{
  for(j in 1:length(lambda)){theta[j,]<-rmvnorm(1,mu[j,],solve(k[j]*lambda[[j]]))}
  return(theta)
}
